function varargout = GUI(varargin)
% GUI MATLAB code for GUI.fig
%      GUI, by itself, creates a new GUI or raises the existing
%      singleton*.
%
%      H = GUI returns the handle to a new GUI or the handle to
%      the existing singleton*.
%
%      GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI.M with the given input arguments.
%
%      GUI('Property','Value',...) creates a new GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before GUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help GUI

% Last Modified by GUIDE v2.5 17-May-2014 14:30:41

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before GUI is made visible.
function GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to GUI (see VARARGIN)

set(handles.refframe,'Enable','off');
set(handles.displayframe,'Enable','off');
set(handles.before,'Enable','off');
set(handles.after,'Enable','off');
set(handles.steps,'Enable','off');
set(handles.computesr,'Enable','off');
set(handles.savemat,'Enable','off');

% Choose default command line output for GUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);



% UIWAIT makes GUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = GUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in openfile.
function openfile_Callback(hObject, eventdata, handles)
% hObject    handle to openfile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


[file,path] = uigetfile('.csv', 'CSV file');
if file ~= 0
    set(handles.text1,'String','Loading CSV file');
    filepath = [path,file];
    
        file = csvread(filepath);
        set(handles.text1,'String','CSV file loaded');

        frames = permute(reshape(file.',640,480,[]),[2 1 3]);
        [~,~,c] = size (frames);

        set(handles.framenum,'String',c);
        set(handles.refframe,'Enable','on');
        set(handles.displayframe,'Enable','on');

        handles.framenum = frames;
        guidata(hObject, handles);

end

clear file path frames;
    

function displayframe_Callback(hObject, eventdata, handles)

buff = get(handles.text1,'String');

if strcmp(buff,'No CSV file opened')
    warndlg ('No CSV file is opened!');
else
    frame = str2double(get(handles.refframe,'String'));
    frames = handles.framenum;
    [a,b,c] = size (frames);
    a = int2str(a);
    b = int2str(b);
    x = ' x ';
    refres = [b,x,a];
        
    if frame > 0 && frame <= c
        imagesc(frames(:,:,frame), 'Parent', handles.axes1);
        set(handles.before,'Enable','on');
        set(handles.after,'Enable','on');
        set(handles.steps,'Enable','on');
        set(handles.computesr,'Enable','on');
        set(handles.refimageresol,'String',refres);
        set(handles.compsettings,'String','Please choose computation settings bellow');
    else
        warndlg ('Frame Number must be from 1 to Maximum Number of Frames!');
    end
end


function refframe_Callback(hObject, eventdata, handles)
% hObject    handle to refframe (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of refframe as text
%        str2double(get(hObject,'String')) returns contents of refframe as a double


function before_CreateFcn(hObject, eventdata, handles)
% hObject    handle to refframe (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function after_CreateFcn(hObject, eventdata, handles)
% hObject    handle to refframe (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function steps_CreateFcn(hObject, eventdata, handles)
% hObject    handle to refframe (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function refframe_CreateFcn(hObject, eventdata, handles)
% hObject    handle to refframe (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in computesr.
function computesr_Callback(hObject, eventdata, handles)
% hObject    handle to computesr (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[~,~,c] = size(handles.framenum);
frame = str2double(get(handles.refframe,'String'));
before = str2double(get(handles.before,'String'));
after = str2double(get(handles.after,'String'));
step = str2double(get(handles.steps,'String'));

if step >=1 && step <=10
    if before < frame && before > 0
        if after < c - frame && after > 0
            if (get(handles.wiener,'Value') == 0) && (get(handles.interpolation,'Value') == 0) && (get(handles.nofiltering,'Value') == 0)
                warndlg ('Please select type of filtering');
            else
            set(handles.compsettings,'String','Computing SuperResolution!');
            
            container = registration(handles.framenum,frame,before,after,step);  
            
            
            if (get(handles.wiener,'Value') == 1)
                container = imresize(container,2);
                container = wiener2(container,[16 16]);
            elseif (get(handles.interpolation,'Value') == 1)
                container = imresize(container,2);
                container = imresize(container,1,'bicubic');
            elseif (get(handles.nofiltering,'Value') == 1)
                container = imresize(container,2);                
            end
            
            [a,b] = size(container);
            x = ' x ';
            a = int2str(a);
            b = int2str(b);
            
            %Cut out only inside image
            outres = [b,x,a];
            set (handles.outimageresol,'String',outres);
            set(handles.compsettings,'String','Computation is complete!');
            
            set(handles.savemat,'Enable','on');
            
            imagesc(container, 'Parent', handles.axes2);
            
            handles.container = container;
            guidata(hObject, handles);
            disp('Done');
            
            end
        else
            warndlg ('Number of frames to be used after Reference frame is incorrect!');
        end
    else
        warndlg ('Number of frames to be used before Reference frame is incorrect!');
    end
else
    warndlg ('Step can only be from 1 to 10!');
end

function before_Callback(hObject, eventdata, handles)
% hObject    handle to before (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of before as text
%        str2double(get(hObject,'String')) returns contents of before as a double



function after_Callback(hObject, eventdata, handles)
% hObject    handle to after (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of after as text
%        str2double(get(hObject,'String')) returns contents of after as a double



function steps_Callback(hObject, eventdata, handles)
% hObject    handle to steps (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of steps as text
%        str2double(get(hObject,'String')) returns contents of steps as a double


% --- Executes on button press in wiener.
function wiener_Callback(hObject, eventdata, handles)
% hObject    handle to wiener (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of wiener
set(handles.nofiltering,'Value',0);
set(handles.interpolation,'Value',0);


% --- Executes on button press in interpolation.
function interpolation_Callback(hObject, eventdata, handles)
% hObject    handle to interpolation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of interpolation
set(handles.nofiltering,'Value',0);
set(handles.wiener,'Value',0);


% --- Executes on button press in nofiltering.
function nofiltering_Callback(hObject, eventdata, handles)
% hObject    handle to nofiltering (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of nofiltering
set(handles.interpolation,'Value',0);
set(handles.wiener,'Value',0);

% --- Executes on button press in saveimage.


% --- Executes on button press in savemat.
function savemat_Callback(hObject, eventdata, handles)
% hObject    handle to savemat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
containertosave = handles.container;
variables = 'containertosave';
uisave(variables);
