function [final_container] = registration(frames,frame,before,after,step)
%---- Take the Reference frame from the middle of sequence
f = frames (:,:,frame);

container = ones(1500,1500)* (-99);
container2 = ones(1500,1500)* (-99);
container3 = zeros(1500,1500);

[~,~,a3] = size (frames);
[y,x] = size (f);
[y2,x2] = size (container);

start = frame - before*step;
finish = frame + after*step;
if start < 1
    start = 1;
end
if finish > a3
    finish = a3;
end

container(((y2-y)/2):(((y2-y)/2)+y-1),((x2-x)/2):(((x2-x)/2)+x-1)) = f;

top = 0;
left = 0;
right = 0;
bottom = 0;

for FrameNo = start : step : finish
   
    clc;
    disp(((FrameNo - start + 1)/(finish - start))*100);
    
g = frames (:,:,FrameNo);
%--------------------------------------------------------------------------

[output] = dftregistration(fft2(f),fft2(g),10);

%-------------------------------------------------------------------------------------
rotation = round(output(2));
rowshift = round(output(3));
colshift = round(output(4));

%--- Shift g and put it to container--------
buffer = imrotate(g, rotation);
[m,n] = size (buffer);
[m2,n2] = size (container2);
container2((((m2-m)/2)+rowshift):(((m2-m)/2)+ m + rowshift -1 ),(((n2-n)/2)+colshift):(((n2-n)/2) + n + colshift-1)) = buffer;



for y = 1 : m2-1
    for x = 1 : n2-1
        
        if (container(y,x) ~= -99) && (container2 (y,x) ~= -99)
            container (y,x) = container(y,x) + container2(y,x);
            container3 (y,x) = container3 (y,x) + 1;
        
        elseif (container(y,x) == -99) && (container2 (y,x) == -99)
            container3 (y,x) = 1; 
        
        elseif (container(y,x) == -99) && (container2 (y,x) ~= -99)
            container (y,x) = 0;
            container (y,x) = container(y,x) + container2(y,x);
        end
        
        if (container (y,x+1) ~= -99) && (container(y,x) == -99)
            if left == 0
                left = x+1;
            elseif x+1 < left
                left = x+1;
            end 
        
        elseif (container (y+1,x) ~= -99) && (container(y,x) == -99)
            if top == 0
                top = y+1;
            elseif y+1 < top
                top = y+1;
            end   
        
        elseif (container(y,x+1) == -99) && (container(y,x) ~= -99)
            if right == 0
                right = x;
            elseif x > right && right ~=0
                right = x;
            end
          
        elseif (container(y+1,x) == -99) && (container(y,x) ~= -99)
            if bottom == 0
                bottom = y;
            elseif y > bottom && bottom ~=0
                bottom = y;
            end
        end
    end
end
end



container = container./container3;

container (container == -99) = NaN;

final_container = container (top:bottom,left:right);

% figure(1);
% subplot(1,2,1);
% imagesc(f);
% title('Reference image, cont(x,y)')
% subplot(1,2,2);
% imagesc(container);
% title('Registered image, cont2(x,y)')

return